package icfp.contest;

import java.util.*;
import java.awt.*;

/**
 * Insert the type's description here.
 * 
 * @author: Pablo Pedemonte
 */
public final class NeighbourInfo {

	private char dir;
	private  Point pos;
	
	private byte[] dist1 = new byte[4];
	private  byte[] dist2 = new byte[4];

	/** true if some is in my 1 and 2-cell 
	 * environments, respectively 
	 */
	private boolean dist1Occupied;
	private boolean dist2Occupied;

	/** True if the pos where I am aiming is occupied */
	private boolean aimOccupied;
/**
 * NeighbourInfo constructor comment.
 */
public NeighbourInfo() {
	super();
}
/**
 * Insert the method's description here.
 * 
 */
public void clear() {
	dir = '\0';
	pos = null;
	dist1 = dist2 = null;
	dist1Occupied = dist2Occupied = aimOccupied = false;
}
/**
 * Insert the method's description here.
 * 
 * @return icfp.contest.Advice
 */
public Advice getAdvice() {

	Advice a = new Advice();
	a.setDir(dir);
	
	if (aimOccupied) {
		a.setAction(Advice.HIGH_BID);
		return a;
	}

	if (dist1Occupied) {
		a.setAction(Advice.HIGH_BID);
		if (dist2Occupied) {
			a.setDir(this.getEvadeDir());
		}

		return a;
	}

	if (dist2Occupied) {
		a.setAction(Advice.LOW_BID);
		return a;
	}

	a.setAction(Advice.NORM_BID);
	return a;
}
/**
 * Insert the method's description here.
 * 
 * @return char
 */
private char getEvadeDir() {

	int i;
	int j = 0;
	
	for (i = 0; i < Board.DIR_ARRAY.length; i++) {
		if (Board.DIR_ARRAY[i] == dir) {
			j = i;
			continue;
		}
		if (dist1[i] == Board.HOME || dist1[i] == Board.VOID) {
			break;
		}
	}

	// No escape, must hit someone!
	// Return the direction opposite to the original
	if (i == Board.DIR_ARRAY.length) {
		return Board.DIR_ARRAY[(j + 2) % Board.DIR_ARRAY.length];
	}

	return Board.DIR_ARRAY[i];
}
/**
 * Insert the method's description here.
 * 
 * @param newAimOccupied boolean
 */
public void setAimOccupied(boolean newAimOccupied) {
	aimOccupied = newAimOccupied;
}
/**
 * Insert the method's description here.
 * 
 * @param newDir char
 */
public void setDir(char newDir) {
	dir = newDir;
}
/**
 * Insert the method's description here.
 * 
 * @param newDist1 byte[]
 */
public void setDist1(byte[] newDist1) {
	dist1 = newDist1;
}
/**
 * Insert the method's description here.
 * 
 * @param newDist1Occupied boolean
 */
public void setDist1Occupied(boolean newDist1Occupied) {
	dist1Occupied = newDist1Occupied;
}
/**
 * Insert the method's description here.
 * 
 * @param newDist2 byte[]
 */
public void setDist2(byte[] newDist2) {
	dist2 = newDist2;
}
/**
 * Insert the method's description here.
 * 
 * @param newDist2Occupied boolean
 */
public void setDist2Occupied(boolean newDist2Occupied) {
	dist2Occupied = newDist2Occupied;
}
/**
 * Insert the method's description here.
 * 
 * @param newPos java.awt.Point
 */
public void setPos(java.awt.Point newPos) {
	pos = newPos;
}
}
